var stylenr;
var stylemin = 0;
var stylemax = 4;

function Setup() {
    //Standardeinstellungen schreiben
    //System.Sound.beep();
    System.Gadget.Settings.write("font", 6);
    System.Gadget.Settings.write("bigfont", false);
    System.Gadget.Settings.write("backstyle", 0);
    System.Gadget.Settings.write("laststate", 0);
    System.Gadget.Settings.write("onloadzeit", true);
    System.Gadget.Settings.write("onloadwlan", false);
    System.Gadget.Settings.write("onloadakku", false);
    System.Gadget.Settings.write("onloadsys", false);
    System.Gadget.Settings.write("onloadtemp", false);
    System.Gadget.Settings.write("onloaddrive", false);
    System.Gadget.Settings.write("onloadtrash", false);
    System.Gadget.Settings.write("onloadsdc", false);
    System.Gadget.Settings.write("viewzeit", true);
    System.Gadget.Settings.write("viewwlan", true);
    System.Gadget.Settings.write("viewakku", true);
    System.Gadget.Settings.write("viewsys", true);
    System.Gadget.Settings.write("viewtemp", false);
    System.Gadget.Settings.write("viewdrive", true);
    System.Gadget.Settings.write("viewtrash", true);
    System.Gadget.Settings.write("viewsdc", true);
    System.Gadget.Settings.write("akkulow", 20);
    System.Gadget.Settings.write("akkukrit", 10);
    System.Gadget.Settings.write("cpuhigh", 60);
    System.Gadget.Settings.write("cpufull", 95);

    //Grundeinstellungen sind gespeichert!
    System.Gadget.Settings.write("Setup", 1);
}

function resetsettings() {
    Setup();
    initSettings();
}

function settingsnav(index) {
    startup.style.display = "none";

    for (i = 0; i < 5; i++) {
        cont[i].style.display = "none";
        nav[i].style.color = "black";
        nav[i].style.fontWeight = "normal";
    }

    cont[index].style.display = "inline";
    cont[index].style.visibility = "visible";
    nav[index].style.color = "#777777";
    nav[index].style.fontWeight = "bold";
}

function initSettings() {
    //Event-Handler
    System.Gadget.onSettingsClosing = settingsclosing;

    //gespeicherte Einstellungen laden...
    ziel.selectedIndex = System.Gadget.Settings.read("font");
    bigfont.checked = System.Gadget.Settings.read("bigfont");
    stylenr = System.Gadget.Settings.read("backstyle");
    showstyle();
    if (System.Gadget.Settings.read("laststate") == 0)
        startselect.checked = true
    else
        startlast.checked = true;
    zeitcheck.checked = System.Gadget.Settings.read("onloadzeit");
    wlancheck.checked = System.Gadget.Settings.read("onloadwlan");
    akkucheck.checked = System.Gadget.Settings.read("onloadakku");
    syscheck.checked = System.Gadget.Settings.read("onloadsys");
    tempcheck.checked = System.Gadget.Settings.read("onloadtemp");
    drivecheck.checked = System.Gadget.Settings.read("onloaddrive");
    trashcheck.checked = System.Gadget.Settings.read("onloadtrash");
    sdccheck.checked = System.Gadget.Settings.read("onloadsdc");
    startvisible();
    zeit1check.checked = System.Gadget.Settings.read("viewzeit");
    wlan1check.checked = System.Gadget.Settings.read("viewwlan");
    akku1check.checked = System.Gadget.Settings.read("viewakku");
    sys1check.checked = System.Gadget.Settings.read("viewsys");
    temp1check.checked = System.Gadget.Settings.read("viewtemp");
    drive1check.checked = System.Gadget.Settings.read("viewdrive");
    trash1check.checked = System.Gadget.Settings.read("viewtrash");
    sdc1check.checked = System.Gadget.Settings.read("viewsdc");
    akkulow.value = System.Gadget.Settings.read("akkulow");
    akkukrit.value = System.Gadget.Settings.read("akkukrit");
    cpuhigh.value = System.Gadget.Settings.read("cpuhigh");
    cpufull.value = System.Gadget.Settings.read("cpufull");

    settingsnav(0);

    vers.innerHTML = "Version: " + System.Gadget.version;
}

function settingsclosing(event) {
    if (event.closeAction == event.Action.commit) {
        //neue Einstellungen prfen...
        checknew();

        //Einstellungen speichern
        System.Gadget.Settings.write("font", ziel.selectedIndex);
        System.Gadget.Settings.write("bigfont", bigfont.checked);
        System.Gadget.Settings.write("backstyle", stylenr);
        if (startselect.checked) {
            System.Gadget.Settings.write("laststate", 0);
            System.Gadget.Settings.write("onloadzeit", zeitcheck.checked);
            System.Gadget.Settings.write("onloadwlan", wlancheck.checked);
            System.Gadget.Settings.write("onloadakku", akkucheck.checked);
            System.Gadget.Settings.write("onloadsys", syscheck.checked);
            System.Gadget.Settings.write("onloadtemp", tempcheck.checked);
            System.Gadget.Settings.write("onloaddrive", drivecheck.checked);
            System.Gadget.Settings.write("onloadtrash", trashcheck.checked);
            System.Gadget.Settings.write("onloadsdc", sdccheck.checked);
        } else {
            System.Gadget.Settings.write("laststate", 1);
            checktosave();
        }
        System.Gadget.Settings.write("viewzeit", zeit1check.checked);
        System.Gadget.Settings.write("viewwlan", wlan1check.checked);
        System.Gadget.Settings.write("viewakku", akku1check.checked);
        System.Gadget.Settings.write("viewsys", sys1check.checked);
        System.Gadget.Settings.write("viewtemp", temp1check.checked);
        System.Gadget.Settings.write("viewdrive", drive1check.checked);
        System.Gadget.Settings.write("viewtrash", trash1check.checked);
        System.Gadget.Settings.write("viewsdc", sdc1check.checked);
        System.Gadget.Settings.write("akkulow", akkulow.value);
        System.Gadget.Settings.write("akkukrit", akkukrit.value);
        System.Gadget.Settings.write("cpuhigh", cpuhigh.value);
        System.Gadget.Settings.write("cpufull", cpufull.value);
    } else if (event.closeAction == event.Action.cancel) {
        //Abbrechen gewhlt

    }
}

function settingsclosed() {

    //aktualisieren
    init2();
    layout();
    getall();
}


function startvisible() {
    if (startselect.checked) {
        zeitcheck.disabled = false;
        wlancheck.disabled = false;
        akkucheck.disabled = false;
        syscheck.disabled = false;
        tempcheck.disabled = false;
        drivecheck.disabled = false;
        trashcheck.disabled = false;
        sdccheck.disabled = false;
    } else {
        zeitcheck.disabled = true;
        wlancheck.disabled = true;
        akkucheck.disabled = true;
        syscheck.disabled = true;
        tempcheck.disabled = true;
        drivecheck.disabled = true;
        trashcheck.disabled = true;
        sdccheck.disabled = true;
    }
}

function stylenav(dir) {
    stylenr = eval(stylenr + dir);
    if (stylenr < stylemin) stylenr = stylemax;
    if (stylenr > stylemax) stylenr = stylemin;

    showstyle();
}

function showstyle() {
    tmpstylenr = stylenr;
    if (tmpstylenr < 10) tmpstylenr = "0" + tmpstylenr;
    styleid.innerHTML = " Design " + (stylenr + 1) + "/" + (stylemax + 1) + " ";
    stylepic.style.backgroundImage = "url('images/" + tmpstylenr + "style.png')";
}



//##################################
//Einstellungen vor Speichern prfen

function checknew() {
    pruefeAnzeige();
    pruefeAkku();
    pruefeSys();
}

function pruefeAnzeige() {
    if (zeit1check.checked == false &&
            wlan1check.checked == false &&
            akku1check.checked == false &&
            sys1check.checked == false &&
            temp1check.checked == false &&
            drive1check.checked == false &&
            trash1check.checked == false &&
            sdc1check.checked == false) zeit1check.checked = true;
}

function pruefeAkku() {
    if (akkulow.value < 1 || akkulow.value > 99 || isNaN(akkulow.value)) {
        settingsnav(3);
        error.innerHTML = "low power level error:<br />";
        error.innerHTML += pholder() + " minimum value > 0";
        error.innerHTML += pholder() + " maximum value < 99";
        throw ("AkkuError");
    }
    if (akkukrit.value < 0 || akkukrit.value >= akkulow.value || isNaN(akkukrit.value)) {
        settingsnav(3);
        error.innerHTML = "critical power level error:<br />";
        error.innerHTML += pholder() + " minimum value >= 0";
        error.innerHTML += pholder() + " maximum value < low power level";
        throw ("AkkuError");
    }
}

function pruefeSys() {
    if (cpuhigh.value < 0 || cpuhigh.value > 99 || isNaN(cpuhigh.value)) {
        settingsnav(3);
        error.innerHTML = "High CPU-Usage error:<br />";
        error.innerHTML += pholder() + " minimum value > 0";
        error.innerHTML += pholder() + " maximum value < 99";
        throw ("SysError");
    }
    if (cpufull.value < cpuhigh.value || cpufull.value > 100 || isNaN(cpufull.value)) {
        settingsnav(3);
        error.innerHTML = "Full CPU-Usage error:<br />";
        error.innerHTML += pholder() + " minimum value > high CPU-Usage";
        error.innerHTML += pholder() + " maximum value <= 100";
        throw ("SysError");
    }
}